# Tutorials

These tutorials relate to the version of AllenNLP at the git commit SHA you are currently looking at (likely the HEAD commit of the master branch).  If you want to see the tutorials that relate to the latest pip release, please see https://github.com/allenai/allennlp/tree/v0.7.1/tutorials.

## Getting Started

* [Installation](../README.md#installation)
* [Laziness in AllenNLP](getting_started/laziness.md)

#### A Walk Through AllenNLP

* [Part 1 - Training and Evaluating Models](getting_started/walk_through_allennlp/training_and_evaluating.md)
* [Part 2 - Configuring Experiments](getting_started/walk_through_allennlp/configuration.md)
* [Part 3 - Creating a Model](getting_started/walk_through_allennlp/creating_a_model.md)

#### A Complete Example: Predicitng Paper Venues

* [Part 1 - Datasets and Models](getting_started/predicting_paper_venues/predicting_paper_venues_pt1.md)
* [Part 2 - Predictions and Demos](getting_started/predicting_paper_venues/predicting_paper_venues_pt2.md)

## How-to

* [Using span representations](how_to/span_representations.md)
* [Using pre-trained ELMo representations](how_to/elmo.md)
* [How to train a model with lazy data](how_to/laziness.md)
* [How to visualize model internals (BETA)](how_to/visualizing_model_internals.md)

## Deeper Dives

* [Datasets, Instances, and Fields](notebooks/data_pipeline.ipynb)
* [Vocabularies](notebooks/vocabulary.ipynb)
